<template>
  <label-canvas
    :sorted-labels="sortedLabels"
    :selected-id="null"
    :is-focused="false"
    :source="source"
    :zoom="zoom"
    :show-image="showImage"
    :render-staves="false"
  >
    <template #svgInjector>
      <canvas-source-base :source="source" />
    </template>
    <template #default="{ canvas }">
      <b-minimap-cursor
        :view-rect="viewRect"
        :height="source.height"
      />
      <b-minimap-click-scroll
        :view-rect="viewRect"
        :canvas="canvas"
        :scroll-to="goTo"
      />
      <slot :canvas="canvas" />
    </template>
  </label-canvas>
</template>
<script lang="ts">
import {
  Vue, Component, Prop, Watch,
} from 'vue-property-decorator';
import LabelCanvas from '@/components/canvas/LabelCanvas.vue';

// Behaviors
import BSeekOnShiftClick from '@/components/behaviors/player/BSeekOnShiftClick.vue';
import BCanvasCursor from '@/components/behaviors/player/BCanvasCursor.vue';
import BMinimapCursor from '@/components/behaviors/scroll/BMinimapCursor.vue';
import BMinimapClickScroll from '@/components/behaviors/scroll/BMinimapClickScroll.vue';

// Logic
import type { Label, Rect, Source } from '@/data';
import type { ScrollTo } from '@/logic/ScrollActions';

// Addons
import CanvasSourceBase from '@/components/canvas-sources/CanvasSourceBase.vue';

/**
 * A specialized label-canvas for minimaps
 */
@Component({
  components: {
    CanvasSourceBase,
    // All the canvas behaviors used
    BSeekOnShiftClick,
    BCanvasCursor,

    // All the minimap behaviors used
    BMinimapCursor,
    BMinimapClickScroll,

    // All the canvas add-ons and UI tools
    LabelCanvas,
  },
})
export default class Minimap extends Vue {
  @Prop({ required: true })
  sortedLabels!: Label[];

  @Prop({ required: true })
  viewRect!: Rect;

  @Prop({ required: true })
  source!: Source;

  @Prop({ required: true })
  goTo!: ScrollTo;

  @Prop({ required: true, type: Boolean })
  showImage!: boolean;

  zoom = 0.01;

  mounted() {
    this.viewRectUpdated();
  }

  @Watch('viewRect.width')
  viewRectUpdated() {
    this.zoom = this.viewRect.width / (this.source.width / this.source.zoom.value);
    if (this.viewRect.height * this.zoom < 25) {
      this.zoom = 25 / this.viewRect.height;
    }
    if (this.viewRect.height * this.zoom > 50) {
      this.zoom = 50 / this.viewRect.height;
    }
  }
}
</script>

<style lang="scss" scoped>
::v-deep .label-rect {
  pointer-events: none !important;
}
</style>
